export class Main extends Indicator {

    constructor() {
        super();

        this.setProperty(Property.SeparateWindow, true);
        this.setProperty(Property.ShortName, "A/D");

        this.addInput("PriceType", InputType.PriceType, PriceType.Bid);

        this.buffers = {
            ExtMapBuffer1 : this.addBuffer(),
        };
    }

    onInit() {
        this.buffers.ExtMapBuffer1
            .setShape(Shape.Line)
            .setColor(Color.LightSeaGreen)
        ;
    }

    async onUpdate() {
        const  {PriceType} = this.getInputs(),
            {ExtMapBuffer1} = this.buffers,
            {
                High,
                Low,
                Close,
                Volume
            } = await Bar.load([
                Bar.Mode.High,
                Bar.Mode.Low,
                Bar.Mode.Close,
                Bar.Mode.Volume,
            ], PriceType),
            barSize = Close.length;

        let i,  h, l, c,
            countedBars = Bar.counted();

        i = barSize - countedBars - 1;

        while (i >= 0) {
            h = High[i];
            l = Low[i];
            c = Close[i];

            ExtMapBuffer1.set(i,  ((c - l) - (h - c)));
            if (ExtMapBuffer1.get(i) !== 0) {
                let diff = h - l;
                if (0 === diff) {
                    ExtMapBuffer1.set(i, 0);
                }
                else {
                    ExtMapBuffer1.set(i, (ExtMapBuffer1.get(i)/diff));
                    ExtMapBuffer1.set(i, (ExtMapBuffer1.get(i) * Volume[i]));
                }
            }
            if (i < barSize - 1) {
                ExtMapBuffer1.set(i, (ExtMapBuffer1.get(i) + ExtMapBuffer1.get((i + 1))));
            }
            i--;
        }
    }
}